--***********************************************
--* Library declaration
--***********************************************
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


LIBRARY UNISIM;
use UNISIM.VCOMPONENTS.ALL;


ENTITY xst_vhdl_bl4cl3 IS
 PORT (
 cntrl0_DDR_DQ : inout  std_logic_vector(15  downto 0);
cntrl0_DDR_A : out  std_logic_vector(12  downto 0);
cntrl0_DDR_BA : out  std_logic_vector(1  downto 0);
cntrl0_DDR_CK : out std_logic;
cntrl0_DDR_CK_N : out std_logic;
cntrl0_DDR_CKE : out std_logic;
cntrl0_DDR_CS_N : out std_logic;
cntrl0_DDR_RAS_N : out std_logic;
cntrl0_DDR_CAS_N : out std_logic;
cntrl0_DDR_WE_N : out std_logic;
cntrl0_DDR_DM : out  std_logic_vector(1  downto 0);
--S3E_STARTER cntrl0_rst_dqs_div_in : in std_logic;
--S3E_STARTER cntrl0_rst_dqs_div_out : out std_logic;
cntrl0_rst_dqs_div : inout std_logic; 	--S3E_STARTER 
--S3E_STARTER SYS_CLKb : in std_logic;
SYS_CLK : in std_logic;
--S3E_STARTER reset_in : in std_logic;
reset : in std_logic;	 				--S3E_STARTER
cntrl0_led_error_output1 : out std_logic;
DATA_VALID : out std_logic; 			--S3E_STARTER
cntrl0_DDR_DQS : inout  std_logic_vector(1  downto 0)

);  
      
END xst_vhdl_bl4cl3;

ARCHITECTURE arch OF xst_vhdl_bl4cl3 IS

--component IBUFGDS_LVDS_25
  --port ( I  : in std_logic;
    --     IB : in std_logic;
      --   O  : out std_logic);
--end component;


    
COMPONENT xst_vhdl_bl4cl3_infrastructure_top 
   PORT (
         reset_in           : in std_logic;
	  --   clk180             : in std_logic;        -- clk180 added
      --   clk270             : in std_logic;	   -- clk270 added
         wait_200us         : out std_logic;
         delay_sel_val1_val_rl : out std_logic_vector(4 downto 0);
         delay_sel_val1_val_tb : out std_logic_vector(4 downto 0); 
         sys_rst_val        : out std_logic;
         sys_rst90_val      : out std_logic;
         clk_int_val        : out std_logic;
         clk90_int_val      : out std_logic; 
        -- sys_clk_ibuf       : in std_logic;
	   --S3E_STARTER SYS_CLKb : in std_logic; 
         SYS_CLK : in std_logic;

         sys_rst180_val     : out std_logic;
         sys_rst270_val     : out std_logic
 
	  );   

END COMPONENT;


COMPONENT xst_vhdl_bl4cl3_main_0 IS
   PORT (

wait_200us        : in std_logic;
delay_sel_val     : in STD_LOGIC_VECTOR(4 downto 0);
clk_int           : in std_logic;
clk90_int         : in std_logic;
--clk180	      : in std_logic; 
--clk270	      : in std_logic;  
sys_rst_val       : in std_logic;
sys_rst90_val     : in std_logic;
sys_rst180_val    : in std_logic;
sys_rst270_val    : in std_logic;
--reset_in          : in STD_LOGIC;

  DDR_DQ : inout  std_logic_vector(15  downto 0);
DDR_A : out  std_logic_vector(12  downto 0);
DDR_BA : out  std_logic_vector(1  downto 0);
DDR_CK : out std_logic;
DDR_CK_N : out std_logic;
DDR_CKE : out std_logic;
DDR_CS_N : out std_logic;
DDR_RAS_N : out std_logic;
DDR_CAS_N : out std_logic;
DDR_WE_N : out std_logic;
DDR_DM : out  std_logic_vector(1  downto 0);
rst_dqs_div_in : in std_logic;
rst_dqs_div_out : out std_logic;
led_error_output1 : out std_logic;
data_valid_out1  : out std_logic; 	--S3E_STARTER
DDR_DQS : inout  std_logic_vector(1  downto 0)
         );   
END COMPONENT;

--signal sys_clk_ibuf :  std_logic;
signal sys_rst    :  std_logic;
signal wait_200us :  std_logic;
signal sys_rst90  :  std_logic;
signal sys_rst180 :  std_logic;
signal sys_rst270 :  std_logic;
signal clk_int    :  std_logic;
signal clk90_int  :  std_logic;

signal delay_sel_tb :  std_logic_vector(4 downto 0);
signal delay_sel_rl :  std_logic_vector(4 downto 0); 
signal reset_in		:  std_logic;	--S3E_STARTER

BEGIN 
reset_in <= not reset; --S3E_STARTER
--clk180 <= not clk_int;
--clk270 <= not clk90_int;


 infrastructure_top0 : xst_vhdl_bl4cl3_infrastructure_top 
 PORT MAP (
 --added
--S3E_STARTER SYS_CLKb	=> SYS_CLKb,
SYS_CLK	=> SYS_CLK,
--S3E_STARTER reset_in	=> reset_in,
reset_in	=> reset_in,
          -- clk180                => clk180,
	      -- clk270                => clk270,
             wait_200us            => wait_200us,
             delay_sel_val1_val_rl => delay_sel_rl,
             delay_sel_val1_val_tb => delay_sel_tb, 
       	      clk_int_val      => clk_int,
       	      clk90_int_val    => clk90_int,
	
               --   sys_clk_ibuf   => sys_clk_ibuf,
                  sys_rst_val    => sys_rst,
                  sys_rst90_val  => sys_rst90,
                  sys_rst180_val => sys_rst180,
                  sys_rst270_val => sys_rst270
                );


 main_00 : xst_vhdl_bl4cl3_main_0
   PORT MAP (

wait_200us         => wait_200us, 
delay_sel_val      => delay_sel_rl, 
clk_int            => clk_int,
clk90_int          => clk90_int,
--clk180             => clk180,
--clk270             => clk270,
sys_rst_val        => sys_rst,
sys_rst90_val      => sys_rst90,
sys_rst180_val     => sys_rst180,
sys_rst270_val     => sys_rst270,
--reset_in           => reset_in,


DDR_DQ	=> cntrl0_DDR_DQ,
DDR_A	=> cntrl0_DDR_A,
DDR_BA	=> cntrl0_DDR_BA,
DDR_CK	=> cntrl0_DDR_CK,
DDR_CK_N	=> cntrl0_DDR_CK_N,
DDR_CKE	=> cntrl0_DDR_CKE,
DDR_CS_N	=> cntrl0_DDR_CS_N,
DDR_RAS_N	=> cntrl0_DDR_RAS_N,
DDR_CAS_N	=> cntrl0_DDR_CAS_N,
DDR_WE_N	=> cntrl0_DDR_WE_N,
DDR_DM	=> cntrl0_DDR_DM,
--S3E_STARTER rst_dqs_div_in	=> cntrl0_rst_dqs_div_in,
rst_dqs_div_in	=> cntrl0_rst_dqs_div,
--S3E_STARTER rst_dqs_div_out	=> cntrl0_rst_dqs_div_out,
rst_dqs_div_out	=> cntrl0_rst_dqs_div,
led_error_output1	=> cntrl0_led_error_output1,
data_valid_out1		=> DATA_VALID,  --S3E_STARTER
DDR_DQS	=> cntrl0_DDR_DQS);   
   
END arch;
