library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.xst_vhdl_bl4cl3_parameters_0.all;
-- use work.parameter_64bit_00.all;
--library synplify; 
--use synplify.attributes.all;
--
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on

entity  xst_vhdl_bl4cl3_RAM8D_0 is
port ( DOUT  : out std_logic_vector((DatabitsPerReadClock -1) downto 0);
       WADDR : in std_logic_vector(3 downto 0);
	  DIN   : in std_logic_vector((DatabitsPerReadClock -1) downto 0);
	  RADDR : in std_logic_vector(3 downto 0);
	  WCLK0 : in std_logic;
	  WCLK1 : in std_logic;
	  WE    : in std_logic
	 );
end xst_vhdl_bl4cl3_RAM8D_0 ;

architecture arc of xst_vhdl_bl4cl3_RAM8D_0 is

  component RAM16X1D
  port (D     : in std_logic;
        WE    : in std_logic;
        WCLK  : in std_logic;
        A0    : in std_logic;
        A1    : in std_logic;
        A2    : in std_logic;
        A3    : in std_logic;
        DPRA0 : in std_logic;
        DPRA1 : in std_logic;
        DPRA2 : in std_logic;
        DPRA3 : in std_logic;
 	SPO   : out std_logic;
        DPO   : out std_logic);
  end component;

begin


fifo_bit0 : RAM16X1D               
port map (DPO    => DOUT(0),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(0),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
          WCLK   => WCLK1,
	  SPO    => OPEN,          
          WE     => WE );                       


fifo_bit1 : RAM16X1D               
port map (DPO    => DOUT(1),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(1),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
          WCLK   => WCLK0, 
          SPO    => OPEN,          
          WE     => WE );   

fifo_bit2 : RAM16X1D               
port map (DPO    => DOUT(2),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(2),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
	  SPO    => OPEN, 
          WCLK   => WCLK1,          
          WE     => WE );                       


fifo_bit3 : RAM16X1D               
port map (DPO    => DOUT(3),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(3),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
          SPO    => OPEN, 
          WCLK   => WCLK0,          
          WE     => WE );   

fifo_bit4: RAM16X1D               
port map (DPO    => DOUT(4),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(4),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
          SPO    => OPEN, 
          WCLK   => WCLK1,          
          WE     => WE );                       


fifo_bit5 : RAM16X1D               
port map (DPO    => DOUT(5),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(5),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
          SPO    => OPEN, 
          WCLK   => WCLK0,          
          WE     => WE );   

fifo_bit6 : RAM16X1D               
port map (DPO    => DOUT(6),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(6),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
          SPO    => OPEN, 
          WCLK   => WCLK1,          
          WE     => WE );                       


fifo_bit7 : RAM16X1D               
port map (DPO    => DOUT(7),          
          A0     => WADDR(0),          
          A1     => WADDR(1),
          A2     => WADDR(2),
          A3     => WADDR(3),
          D      => DIN(7),      
          DPRA0  => RADDR(0),
          DPRA1  => RADDR(1),
          DPRA2  => RADDR(2),
          DPRA3  => RADDR(3),
          SPO    => OPEN, 
          WCLK   => WCLK0,          
          WE     => WE );   

  




end arc;
