library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
--
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on
  

entity xst_vhdl_bl4cl3_cal_ctl_0 is
port (
	
	clk	    : in std_logic;
	reset	    : in std_logic;
	okToSelTap	 : in std_logic;
	flop2	    : in std_logic_vector(31 downto 0);
	tapForDqs_tb   : out std_logic_vector(4 downto 0);
	tapForDqs_rl   : out std_logic_vector(4 downto 0)
	);
end xst_vhdl_bl4cl3_cal_ctl_0 ;

architecture arc_cal_ctl of xst_vhdl_bl4cl3_cal_ctl_0 is



signal      	cnt 		: std_logic_vector(5 downto 0);
signal  	     cnt1		: std_logic_vector(5 downto 0);
signal   trans_oneDtct		: std_logic;
signal   trans_twoDtct		: std_logic;
signal 	 phase_cnt        : std_logic_vector(4 downto 0);
signal 	tap_dly_reg		: std_logic_vector(31 downto 0);	
signal  enb_trans_two_dtct    : std_logic; 
signal  tapForDqs_val_rl   	: std_logic_vector(4 downto 0);
signal  tapForDqs_val_tb   	: std_logic_vector(4 downto 0);
--signal  tap_dly_reg_val     : std_logic; 
signal  cnt_val    : integer; 

--attribute syn_keep : boolean;  
--attribute syn_keep of          cnt 	 : signal is true;
--attribute syn_keep of          cnt1 	 : signal is true;
--attribute syn_keep of trans_oneDtct	 : signal is true;
--attribute syn_keep of trans_twoDtct 	 : signal is true;
--attribute syn_keep of tap_dly_reg        : signal is true;
--attribute syn_keep of enb_trans_two_dtct : signal is true;
--attribute syn_keep of phase_cnt 		 : signal is true;
--attribute syn_keep of tapForDqs_val_tb   : signal is true;
--attribute syn_keep of tapForDqs_val_rl   : signal is true; 



--attribute preserve_signal                       : boolean;  
--attribute preserve_signal of          cnt 	: signal is true;
--attribute preserve_signal of          cnt1 	: signal is true;
--attribute preserve_signal of trans_oneDtct	: signal is true;
--attribute preserve_signal of trans_twoDtct 	: signal is true;
--attribute preserve_signal of tap_dly_reg        : signal is true;
--attribute preserve_signal of enb_trans_two_dtct : signal is true;
--attribute preserve_signal of phase_cnt 		: signal is true;
--attribute preserve_signal of tapForDqs_val_tb   : signal is true;
--attribute preserve_signal of tapForDqs_val_rl   : signal is true;


constant tap1   : std_logic_vector(4 downto 0)    := "01111";
constant tap2   : std_logic_vector(4 downto 0)    := "10111";
constant tap3   : std_logic_vector(4 downto 0)    := "11011";
constant tap4   : std_logic_vector(4 downto 0)    := "11101";
constant tap5   : std_logic_vector(4 downto 0)    := "11110";
constant tap6   : std_logic_vector(4 downto 0)    := "11111";

constant defaultTap : std_logic_vector(4 downto 0) := "11101";   

  
BEGIN

   
tapForDqs_tb <= tapForDqs_val_tb;
tapForDqs_rl <= tapForDqs_val_rl;   

--   /***************************** Changed on April 9 For Successive Transition********************/
	process(clk) 
	begin
	if (clk'event and clk = '1') then
	   if(reset = '1') then
	      enb_trans_two_dtct <= '0';
	    elsif(phase_cnt >= "00011") then	
	       enb_trans_two_dtct <= '1';
	    else
	       enb_trans_two_dtct <= '0';		
	   end if;
	end if;
	end process;

--   /************************************ Changed on April 6 ************************************/

	process (clk)
	begin
	if(clk'event and clk = '1') then
	   if(reset = '1') then
   	      tap_dly_reg <= "00000000000000000000000000000000";
         elsif(cnt(5) = '1') then
            tap_dly_reg <= flop2;
         else
   	     tap_dly_reg <= tap_dly_reg;
  	   end if;
	end if;
	end process;  

--   /******************** Free Running Counter For Counting 32 States ****************************/
  
	process (clk)
	begin
	if(clk'event and clk = '1') then 
	   if(reset='1' or cnt(5)='1') then
	      cnt(5 downto 0) <= "000000";
         else
	      cnt(5 downto 0) <= cnt(5 downto 0) + "000001";
	   end if;
	end if;
	end process;
 

	process(clk)
	begin
	if(clk'event and clk = '1') then
	   if(reset='1' or cnt1(5)='1') then
	      cnt1(5 downto 0) <= "000000";
         else
	      cnt1(5 downto 0) <= cnt1(5 downto 0) + "000001";
 	   end if;
	end if;
	end process;


	process(clk)
	begin
	if clk'event and clk = '1' then
	   if(reset = '1' or cnt(5) = '1') then
 	      phase_cnt <= "00000";
         elsif (trans_oneDtct='1' and  trans_twoDtct='0') then
            phase_cnt <= phase_cnt + "00001";
         else
           phase_cnt <= phase_cnt;
         end if;
      end if;
      end process;				


--   /******************** Checking For The First Transition *************************************/

	process (clk)
	begin
	if clk'event and clk = '1' then
	   if (reset = '1') then
  	      trans_oneDtct <= '0';
     	      trans_twoDtct <= '0';
 	   elsif(cnt(5) = '1') then -- cnt is 32
		trans_oneDtct <= '0';
		trans_twoDtct <= '0';
   	   elsif (cnt(4 downto 0) = "00000") then
            if (tap_dly_reg(0) = '1') then
                 trans_oneDtct <= '1';
  	         trans_twoDtct <= '0';
            end if;
 	   elsif ( tap_dly_reg(cnt_val) = '1' and trans_twoDtct = '0' ) then
	      if( trans_oneDtct = '1' and enb_trans_two_dtct = '1' ) then
	         trans_twoDtct <= '1';
            else 
		   trans_oneDtct <= '1';
            end if;  
         end if; --for reset
     end if;
     end process;		

cnt_val <= conv_integer(cnt(4 downto 0));
	process ( clk)
	begin
	if clk'event and clk ='1' then
		if(reset= '1') then
 		   tapForDqs_val_rl <= defaultTap;
		elsif(cnt1(4) = '1' and cnt1(3) = '1' and cnt1(2) = '1' and cnt1(1) = '1' and cnt1(0) = '1') then
       	   if ((trans_oneDtct = '0') or (trans_twoDtct = '0') or (phase_cnt > "01011"))   then
		      tapForDqs_val_rl <= tap6;		--S3E_STARTER modified the tap value
		   elsif (phase_cnt > "01000") then
		      tapForDqs_val_rl <= tap5;		--S3E_STARTER modified the tap value
		   else	
		      tapForDqs_val_rl <= tap3;		--S3E_STARTER modified the tap value
		   end if;
	      else  
		   tapForDqs_val_rl <= tapForDqs_val_rl;
		end if;
     end if;	
     end process;



	process ( clk)
	begin
	if clk'event and clk ='1' then
	   if(reset= '1') then
	      tapForDqs_val_tb <= defaultTap;
	   else
	      if((cnt(4) = '1') and (cnt(3) = '1') and (cnt(2) = '1') and (cnt(1) = '1') and (cnt(0) = '1')) then
		   if ((trans_oneDtct = '0') or (trans_twoDtct = '0') or (phase_cnt > "01100"))   then
		      tapForDqs_val_tb <= tap5;
		   elsif (phase_cnt < "01000") then
			tapForDqs_val_tb <= tap1;
		   elsif (phase_cnt < "01001") then
			tapForDqs_val_tb <= tap2;
               elsif (phase_cnt < "01010") then
			tapForDqs_val_tb <= tap3;
		   elsif (phase_cnt < "01100") then
			tapForDqs_val_tb <= tap4;	
		   else	
			tapForDqs_val_tb <= tap1;
		   end if;
	      else  
	 	   tapForDqs_val_tb <= tapForDqs_val_tb;
	      end if;
        end if;	
     end if;
     end process;


end arc_cal_ctl;
