library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

use work.xst_vhdl_bl4cl3_parameters_0.all;
--use work.parameter_64bit_00.all;


entity    xst_vhdl_bl4cl3_ddr1_test_bench_0 is
port(
   --  clk180		  : in std_logic; -- clk180 added to entity
   --  clk270		  : in std_logic; -- clk270 added to entity
     fpga_clk       : in std_logic;
     fpga_rst90     : in std_logic;
     fpga_rst0      : in std_logic;
     fpga_rst180    : in std_logic;
     fpga_rst270    : in std_logic;     
     clk90          : in std_logic;
     burst_done     : out std_logic;
     INIT_DONE      : in std_logic;
     auto_ref_req   : in std_logic;
     ar_done        : in std_logic;
     u_ack          : in std_logic;
     u_data_val     : in std_logic;
     u_data_o       : in std_logic_vector(((2*data_width)-1) downto 0);
--   u_addr         : out std_logic_vector(((row_address  + column_address  + bank_address )- 1) downto 0);
     u_addr         : out std_logic_vector(((row_address  + col_ap_width    + bank_address )- 1) downto 0);
     u_cmd          : out std_logic_vector(2 downto 0);
     u_data_i       : out std_logic_vector(((2*data_width)-1) downto 0);
     u_data_m       : out std_logic_vector(((2*data_mask_width)-1) downto 0);
     u_config_parms : out std_logic_vector(9 downto 0);
     led_error_output : out std_logic;
     data_valid_out : out std_logic     
     );
end   xst_vhdl_bl4cl3_ddr1_test_bench_0 ;  

 
architecture   arc of   xst_vhdl_bl4cl3_ddr1_test_bench_0  is
attribute syn_keep : boolean;

component xst_vhdl_bl4cl3_addr_gen_0  
port(
     clk            : in std_logic;
     rst            : in std_logic;
     addr_rst       : in std_logic;
     addr_inc       : in std_logic;
--   addr_out       : out std_logic_vector(((row_address  + column_address  + bank_address )- 1) downto 0);
     addr_out       : out std_logic_vector(((row_address  + col_ap_width    + bank_address )- 1) downto 0);

     test_cnt_ena   : in std_logic;
     burst_done     : out std_logic;
     cnt_roll       : out std_logic
     );
end component;

component xst_vhdl_bl4cl3_cmd_fsm_0  
port (
      clk          : in std_logic;
      clk90        : in std_logic;
	auto_ref_req : in std_logic;
    --  clk180       : in std_logic;
      cmd_ack      : in std_logic;
      cnt_roll     : in std_logic;
      r_w          : out std_logic;
      refresh_done : in std_logic;
      rst          : in std_logic;
      rst90        : in std_logic;
      rst180       : in std_logic;
      init_val     : in std_logic;
      u_data_val   : in std_logic;
      addr_inc     : out std_logic;
      addr_rst     : out std_logic;
      u_cmd        : out std_logic_vector(2 downto 0);
      init_counter : out std_logic_vector(6 downto 0);
      lfsr_rst     : out std_logic);     
end component;

component	  xst_vhdl_bl4cl3_cmp_data_0
port(
     clk            : in std_logic;
     data_valid     : in std_logic;
     lfsr_data      : in std_logic_vector(((2*data_width)-1) downto 0);
     read_data      : in std_logic_vector(((2*data_width)-1) downto 0);
     rst            : in std_logic;
     led_error_output : out std_logic;
     data_valid_out : out std_logic
     );
end component;  


component	xst_vhdl_bl4cl3_lfsr32_0
port (
        clk      : in std_logic;
        rst      : in std_logic;
        lfsr_rst : in std_logic;
        lfsr_ena : in std_logic;
	  lfsr_data_m : out std_logic_vector(((data_mask_width*2)-1) downto 0);
        lfsr_out : out std_logic_vector(((2*data_width)-1) downto 0)
        );
end component;


signal clk                  : std_logic;
signal clk180               : std_logic;
signal clk270               : std_logic;

signal rst0_r               : std_logic;
signal rst90_r              : std_logic;
signal rst180_r             : std_logic;
signal rst270_r             : std_logic;
--signal user_data_val        : std_logic;
signal addr_inc             : std_logic;
signal addr_rst             : std_logic;
signal cmd_ack              : std_logic;
signal cnt_roll             : std_logic;
signal ctrl_ready           : std_logic;
signal data_valid           : std_logic;
signal lfsr_ena_r             : std_logic;
signal lfsr_ena_w             : std_logic;
signal lfsr_rst_r             : std_logic;
signal lfsr_rst_r1             : std_logic;  --S3E_STARTER
signal lfsr_rst_w             : std_logic;
signal r_w                    : std_logic;

--signal addr                 : std_logic_vector(22 downto 0);

--signal cmd                    : std_logic_vector(6 downto 0);
signal lfsr_data_r            : std_logic_vector(((2*data_width)-1) downto 0);
signal lfsr_data_w            : std_logic_vector(((2*data_width)-1) downto 0);
signal lfsr_data_m_r          : std_logic_vector(((2*data_mask_width)-1) downto 0);
signal lfsr_data_m_w          : std_logic_vector(((2*data_mask_width)-1) downto 0);
--signal addr_out               : std_logic_vector(((row_address  + column_address  + bank_address )- 1) downto 0);
  signal addr_out               : std_logic_vector(((row_address  + col_ap_width    + bank_address )- 1) downto 0);

signal state                  : std_logic_vector(6 downto 0);

signal u_dat_flag	            : std_logic;
signal u_dat_fl		      : std_logic;


begin

--  Input : CONFIG REGISTER FORMAT 
-- config_register = {   EMR(Enable/Disable DLL),
--                       BMR (Normal operation/Normal Operation with Reset DLL),
--                       BMR/EMR,
--                       CAS_latency (3),
--                       Burst type ,
--                       Burst_length (3) }
--
-- Input : COMMAND REGISTER FORMAT
--          000  - NOP
--          001  - Precharge 
--          010  - Auto Refresh
--          011  - SElf REfresh
--          100  - Write Request
--          101  - Load Mode Register
--          110  - Read request
--          111  - Burst terminate
--
-- Input : Address format
--   row address = input address(19 downto 8)
--   column addrs = input address( 7 downto 0)
--
-- provide u_cmd
-- provide u_config_parms

--  Terminals assignment 
--  Input terminals

clk         <= fpga_clk;
clk180      <= not fpga_clk;
clk270      <= not clk90;

cmd_ack     <= u_ack;
data_valid  <= u_data_val;

ctrl_ready  <= '1';

--u_addr(((row_address  + column_address  + bank_address )- 1) downto 0) <= addr_out(((row_address  + column_address  + bank_address )- 1) downto 0);
  u_addr(((row_address  + col_ap_width    + bank_address )- 1) downto 0) <= addr_out(((row_address  + col_ap_width  + bank_address )- 1) downto 0);
u_data_i            <= lfsr_data_w;
u_data_m            <= lfsr_data_m_w;
--u_config_parms      <= "0000110010";
  u_config_parms      <= "000" & cas_latency_value & '0' & burst_length;

--"0000110001";   burst length = 2;
--"0000110010";   burst length = 4;
--"0000110011";   burst length = 8;




process(clk)
begin
  if clk'event and clk = '1' then
    rst0_r <= fpga_rst0;
  end if;
end process;

process(clk90)
begin
  if clk90'event and clk90 = '1' then
    rst90_r <= fpga_rst90;
  end if;
end process;


--process(clk180)
process(clk)
begin
--if clk180'event and clk180 = '1' then 
if clk'event and clk = '0' then 
    rst180_r <= fpga_rst180;
  end if;
end process; 


--process(clk270)
process(clk90)
begin
--if clk270'event and clk270 = '1' then 
if clk90'event and clk90 = '0' then 
    rst270_r <= fpga_rst270;
  end if;
end process;

--*********************************************************
process(clk90)
begin
 if clk90'event and clk90 = '1' then
  if rst90_r = '1' then
     lfsr_ena_r <= '0';
  else
     if (u_data_val = '1') then
         lfsr_ena_r <= '1';
     else
	 lfsr_ena_r <= '0';
     end if;

  end if;
 end if;
end process;

process(clk90)
begin
 if clk90'event and clk90 = '1' then
  if rst90_r = '1' then
     lfsr_ena_w <= '0';
  else
     if ((r_w = '0') and (u_ack = '1')) then
         lfsr_ena_w <= '1';
     else
         lfsr_ena_w <= '0';
     end if;
  end if;
 end if;
end process;

process(clk90)
begin
 if(clk90'event and clk90 = '1') then	--S3E_STARTER
 	if(rst90_r = '1') then
    	u_dat_flag <= '0';
 	else								 --S3E_STARTER
    	u_dat_flag <= cmd_ack;
	end if;
 end if;								 --S3E_STARTER
end process;

u_dat_fl <=  cmd_ack and (not u_dat_flag) and r_w;

lfsr_rst_r1 <= u_dat_fl;  				   --S3E_STARTER

process(clk90)							   --S3E_STARTER
begin									   --S3E_STARTER
 if(clk90'event and clk90 = '1') then	   --S3E_STARTER
 	if(rst90_r = '1') then				   --S3E_STARTER
    	lfsr_rst_r <= '0';				   --S3E_STARTER
 	else								   --S3E_STARTER
    	lfsr_rst_r <= lfsr_rst_r1;		   --S3E_STARTER
	end if;								   --S3E_STARTER
 end if;								   --S3E_STARTER
end process;							   --S3E_STARTER


--*************************************************************************

INST1 :  xst_vhdl_bl4cl3_addr_gen_0  
				 port map ( 
				  --clk            => clk,
			          clk            => clk180,
                          --rst            => rst0_r,
			          rst            => rst180_r,
                            addr_rst       => addr_rst,
                            addr_inc       => addr_inc,
                            addr_out       => addr_out,
                            test_cnt_ena   => ctrl_ready,
                            burst_done     => burst_done,
                            cnt_roll       => cnt_roll);

INST_2 : xst_vhdl_bl4cl3_cmd_fsm_0  
				 port map ( 
                            clk          => clk,
                            clk90        => clk90,
			       --   clk180	     => clk180,
                            cmd_ack      => cmd_ack,
                            cnt_roll     => cnt_roll,
				    auto_ref_req => auto_ref_req,
                            r_w          => r_w,
                            refresh_done => ar_done,
                            rst          => rst0_r,
                            rst90        => rst90_r,
                            rst180       => rst180_r,
                            init_val     => init_done,
                            u_data_val   => u_data_val,
                            addr_inc     => addr_inc,
                            addr_rst     => addr_rst,
                            u_cmd        => u_cmd,
                            init_counter => state,
                            lfsr_rst     => lfsr_rst_w);
                           

INST3	:	xst_vhdl_bl4cl3_cmp_data_0
                  port map ( clk            => clk90,
                            data_valid     => data_valid,
                            lfsr_data      => lfsr_data_r,
                            read_data      => u_data_o,
                            rst            => rst90_r,
                            led_error_output => led_error_output,
                            data_valid_out => data_valid_out
                            );

INST5	:	xst_vhdl_bl4cl3_lfsr32_0 
                port map ( clk      => clk90,
                          rst      => rst90_r,
                          lfsr_rst => lfsr_rst_r,
                          lfsr_ena => lfsr_ena_r,
                          lfsr_data_m => lfsr_data_m_r,
                          lfsr_out => lfsr_data_r);

INST7	:	xst_vhdl_bl4cl3_lfsr32_0
                port map ( clk      => clk90,
                          rst      => rst90_r,
                          lfsr_rst => lfsr_rst_w,
                          lfsr_ena => lfsr_ena_w,
                          lfsr_data_m => lfsr_data_m_w,
                          lfsr_out => lfsr_data_w);


end   arc ;  
