library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.xst_vhdl_bl4cl3_parameters_0.all;
--
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on
--
entity xst_vhdl_bl4cl3_infrastructure_iobs_0   is
 port(
   --   clk180            : in STD_LOGIC; -- clk180 is added to the entity
   --   clk270            : in STD_LOGIC; -- clk270 is added to the entity
     
     
 DDR_CK           : out STD_LOGIC;
 DDR_CK_N         : out STD_LOGIC;

      clk0              : in STD_LOGIC;
      clk90             : in STD_LOGIC
      );
end  xst_vhdl_bl4cl3_infrastructure_iobs_0 ;  

architecture   arc of   xst_vhdl_bl4cl3_infrastructure_iobs_0       is


--attribute syn_keep : boolean;
--attribute xc_props : string;
  
     
---- Component declarations -----

 component IBUFGDS_LVDS_25     
  port ( I  : in std_logic;     
         IB : in std_logic;    
         O  : out std_logic);   
 end component;

 component FDDRRSE 
 port( Q  : out std_logic;
       C0 : in std_logic;
       C1 : in std_logic;
       CE : in std_logic;
       D0 : in std_logic;
       D1 : in std_logic;
       R  : in std_logic;
       S  : in std_logic);
 end component;

 component OBUF
 port (
   O : out std_logic;
   I : in std_logic);
 end component;

---- ******************* ----
---- Signal declarations ----
---- ******************* ----


 	 	 signal ddr1_clk0_q     : std_logic;
 		 signal ddr1_clk0b_q    : std_logic;


signal vcc                  : std_logic;
signal gnd                  : std_logic;
signal clk180               : std_logic;
signal clk270               : std_logic;



begin


 gnd <= '0';
 vcc <= '1';

clk180 <= not clk0;
clk270 <= not clk90;


----  Component instantiations  ----

--- ***********************************
----     This includes instantiation of the output DDR flip flop
----     for ddr clk's and dimm clk's
---- ***********************************************************


U0 : FDDRRSE port map (
                         Q => ddr1_clk0_q ,
                        C0 => clk0,
                        C1 => clk180,
                        CE => vcc,
                        D0 => vcc,
                        D1 => gnd,
                         R => gnd,
                         S => gnd);

U0b : FDDRRSE port map (
                         Q => ddr1_clk0b_q ,
                        C0 => clk0,
                        C1 => clk180,
                        CE => vcc,
                        D0 => gnd,
                        D1 => vcc,
                         R => gnd,
                         S => gnd);




---- ******************************************
---- Ouput BUffers for ddr clk's and dimm clk's
---- ******************************************



	r0  : OBUF port map (
                     I => ddr1_clk0_q,
                     O => DDR_CK);

	r0b: OBUF port map (
                     I => ddr1_clk0b_q,
                     O => DDR_CK_N);




---- ****************************************************

end   arc ;  
