library IEEE;
use IEEE.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
--library synplify; 
--use synplify.attributes.all;
--use work.parameter_64bit_00.all;
use work.xst_vhdl_bl4cl3_parameters_0.all;
--
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on
--
entity    xst_vhdl_bl4cl3_main_0  is
port(
--reset_in          : in STD_LOGIC;
rst_dqs_div_in    : in std_logic;
rst_dqs_div_out   : out std_logic;
 delay_sel_val     : in STD_LOGIC_VECTOR(4 downto 0); 
 clk_int           : in std_logic; 
 wait_200us        : in std_logic; 
 clk90_int         : in std_logic; 
-- clk180	       : in std_logic; -- clk180 added to entity
-- clk270		 : in std_logic; -- clk270 added to entity 
 sys_rst_val       : in std_logic; 
 sys_rst90_val     : in std_logic; 
 sys_rst180_val    : in std_logic; 
 sys_rst270_val    : in std_logic; 


DDR_CKE           : out STD_LOGIC;


 DDR_CK           : out STD_LOGIC;
 DDR_CK_N         : out STD_LOGIC;

DDR_CS_N          : out STD_LOGIC;
DDR_CAS_N         : out STD_LOGIC;
DDR_RAS_N         : out STD_LOGIC;
DDR_WE_N          : out STD_LOGIC;
DDR_A             : out STD_LOGIC_VECTOR((row_address  - 1) downto 0);
DDR_BA            : out STD_LOGIC_VECTOR((bank_address  -1) downto 0);

DDR_DM            : out STD_LOGIC_VECTOR(((data_mask_width) -1) downto 0);

data_valid_out1	  : out std_logic;  --S3E_STARTER


DDR_DQ            : inout STD_LOGIC_VECTOR((data_width -1) downto 0);

DDR_DQS           : inout STD_LOGIC_VECTOR((data_strobe_width -1) downto 0);


led_error_output1 : out std_logic
);
end   xst_vhdl_bl4cl3_main_0  ;  

architecture   arc of   xst_vhdl_bl4cl3_main_0  is

---- Component declarations -----
component xst_vhdl_bl4cl3_ddr1_test_bench_0
port(
clk90            : in std_logic;
--clk180           : in std_logic; -- clk180 added to entity
--clk270	     : in std_logic; -- clk270 added to entity 
fpga_clk        :   in std_logic; 
fpga_rst0       :   in std_logic; 
fpga_rst90      :   in std_logic; 
fpga_rst180     :   in std_logic; 
fpga_rst270     :   in std_logic; 
burst_done	    :	  out	std_logic; 
INIT_DONE        : in std_logic;
auto_ref_req            : in std_logic; 
ar_done          : in std_logic;
u_ack            : in std_logic;
u_data_val       : in std_logic;
u_data_o         : in std_logic_vector(((data_width*2) -1) downto 0);
--u_addr           : out std_logic_vector(((row_address  + column_address  + bank_address )-1) downto 0);
  u_addr           : out std_logic_vector(((row_address  + col_ap_width    + bank_address )-1) downto 0);
u_cmd            : out std_logic_vector(2 downto 0);
u_data_i         : out std_logic_vector(((data_width*2) -1) downto 0);
u_data_m         : out std_logic_vector(((data_mask_width*2) -1) downto 0);
u_config_parms   : out std_logic_vector(9 downto 0);
led_error_output : out std_logic;
data_valid_out   : out std_logic     
);
end component;

component	xst_vhdl_bl4cl3_top_0
port(
auto_ref_req          : out std_logic; 
wait_200us            : in std_logic; 
rst_dqs_div_in        : in std_logic;
rst_dqs_div_out       : out std_logic;
--reset_in              : in std_logic;   
user_input_data       : in std_logic_vector(((data_width*2)-1) downto 0);
user_data_mask        : in std_logic_vector(((data_mask_width*2) -1) downto 0);
user_output_data      : out std_logic_vector(((data_width*2) -1) downto 0):=(OTHERS => 'Z');
user_data_valid       : out std_logic;
--user_input_address    : in std_logic_vector(((row_address  + column_address )-1) downto 0);
  user_input_address    : in std_logic_vector(((row_address  + col_ap_width + bank_address )-1) downto 0);

--user_bank_address     : in std_logic_vector((bank_address -1) downto 0);
user_config_register  : in std_logic_vector(9 downto 0);
user_command_register : in std_logic_vector(2 downto 0);
user_cmd_ack          : out std_logic;      
burst_done            : in std_logic;
init_val              : out std_logic;
ar_done               : out std_logic;




DDR_DQS           : inout STD_LOGIC_VECTOR((data_strobe_width -1) downto 0);


DDR_DQ                : inout std_logic_vector((data_width -1) downto 0):= (OTHERS => 'Z');
DDR_CKE               : out std_logic;
DDR_CS_N               : out std_logic;
DDR_RAS_N              : out std_logic;
DDR_CAS_N              : out std_logic;
DDR_WE_N               : out std_logic;

DDR_DM            : out STD_LOGIC_VECTOR(((data_mask_width) -1) downto 0); 


DDR_BA                : out std_logic_vector((bank_address -1) downto 0);
DDR_A           : out std_logic_vector((row_address -1) downto 0);



 DDR_CK           : out STD_LOGIC;
 DDR_CK_N         : out STD_LOGIC;


clk_int	              :	in  std_logic; 
clk90_int	      :	in  std_logic; 
--clk180                : in  std_logic; -- signal added to entity
--clk270                : in  std_logic; -- signal added to entity
delay_sel_val         : in  std_logic_vector(4 downto 0); 
sys_rst_val		      :	in  std_logic; 
sys_rst90_val	      :	in  std_logic; 
sys_rst180_val	      :	in  std_logic; 
sys_rst270_val	      :	in  std_logic;
clk_out	              :	out std_logic; 
clk90_out	              :	out  std_logic; 

sys_rst_out		      :	out  std_logic; 
sys_rst90_out	      :	out  std_logic 
 
);
end component;
---- Signal declarations used on the diagram ----
signal user_output_data : std_logic_vector(((data_width*2)-1) downto 0);
--signal u1_address              : std_logic_vector(((row_address  + column_address  + bank_address )-1) downto 0);
  signal u1_address              : std_logic_vector(((row_address  + col_ap_width    + bank_address )-1) downto 0);

signal user_data_val1          : std_logic;
signal u1_config_parms         : std_logic_vector(9 downto 0);
signal user_cmd1               : std_logic_vector(2 downto 0);
signal auto_ref_req            : std_logic; 
signal user_ack1               : std_logic;
signal u1_data_i               : std_logic_vector(((data_width*2)-1) downto 0);
signal u1_data_m               : std_logic_vector(((data_mask_width*2)-1) downto 0);
signal burst_done_val1         : std_logic;
signal init_val1               : std_logic;
signal ar_done_val1            : std_logic;
--S3E_STARTER signal data_valid_out1         : std_logic;

signal clk_out1	              :	 std_logic; 
signal clk90_out1	              :  std_logic; 

signal sys_rst_out1		:  std_logic; 
signal sys_rst90_out1	      :  std_logic; 

begin
----  Component instantiations  ----
top0	:	xst_vhdl_bl4cl3_top_0	port	map( 
 auto_ref_req    =>  auto_ref_req, 
 wait_200us    =>  wait_200us, 
rst_dqs_div_in	        =>   rst_dqs_div_in,
rst_dqs_div_out	       =>   rst_dqs_div_out,
--reset_in               =>   reset_in,
user_input_data        =>   u1_data_i,
user_data_mask         =>   u1_data_m,
user_output_data       =>   user_output_data,
user_data_valid        =>   user_data_val1,
user_input_address     =>   u1_address(((row_address  + col_ap_width  + bank_address )-1) downto 0),
user_config_register   =>   u1_config_parms,
user_command_register  =>   user_cmd1,
user_cmd_ack           =>   user_ack1,
burst_done             =>   burst_done_val1,
init_val               =>   init_val1,
ar_done                =>   ar_done_val1,
DDR_DQS                =>   DDR_DQS,
DDR_DQ                =>   DDR_DQ,
DDR_CKE               =>   DDR_CKE,
DDR_CS_N               =>   DDR_CS_N,
 DDR_RAS_N               =>   DDR_RAS_N,
DDR_CAS_N               =>   DDR_CAS_N,
DDR_WE_N               =>   DDR_WE_N,
-- DDR_DM                =>   DDR_DM,

	 DDR_DM                =>   DDR_DM,

 DDR_BA                 =>   DDR_BA,
DDR_A            =>   DDR_A,



DDR_CK            =>    DDR_CK,
DDR_CK_N            =>    DDR_CK_N,

clk90_int	           => clk90_int, 
clk_int                => clk_int,
--clk180                 => clk180,
--clk270                 => clk270,
delay_sel_val          => delay_sel_val, 
sys_rst_val	           => sys_rst_val, 
sys_rst90_val	           => sys_rst90_val, 
sys_rst180_val		     => sys_rst180_val, 
sys_rst270_val             => sys_rst270_val,
clk90_out	           => clk90_out1, 
clk_out                => clk_out1,
sys_rst_out           => sys_rst_out1, 
sys_rst90_out  	           => sys_rst90_out1  
);         
                                   
ddr1_test_bench0	:  xst_vhdl_bl4cl3_ddr1_test_bench_0 port map( 
auto_ref_req           =>  auto_ref_req, 
fpga_clk               =>  clk_int, 
--clk180                 =>  clk180,
--clk270                 =>  clk270,
fpga_rst90	=>	sys_rst90_val, 
fpga_rst0	=>	sys_rst_val, 
fpga_rst180	=>	sys_rst180_val, 
fpga_rst270	=>	sys_rst270_val, 
clk90                 => clk90_int,
burst_done            => burst_done_val1,
INIT_DONE             => init_val1,
ar_done               => ar_done_val1,
u_ack                 => user_ack1,
u_data_val            => user_data_val1,
u_data_o              => user_output_data,
u_addr                => u1_address,
u_cmd                 => user_cmd1, 
u_data_i              => u1_data_i ,
u_data_m              => u1_data_m,
u_config_parms        => u1_config_parms,
led_error_output      => led_error_output1,
data_valid_out        => data_valid_out1
);
end   arc ;  
