library ieee;
use ieee.std_logic_1164.all;

library UNISIM; 
use UNISIM.VCOMPONENTS.ALL;

package  xst_vhdl_bl4cl3_parameters_0  is

constant   data_width                                : INTEGER   :=  16;
constant   data_strobe_width                         : INTEGER   :=  2;
constant   data_mask_width                           : INTEGER   :=  2;
constant   clk_width                                 : INTEGER   :=  1;
constant   fifo_16                                   : INTEGER   :=  1;
constant   ReadEnable                                : INTEGER   :=  1;
constant   row_address                               : INTEGER   :=  13;
constant   column_address                            : INTEGER   :=  10;
constant   bank_address                              : INTEGER   :=  2;
constant   memory_width                              : INTEGER   :=  8;
constant   DatabitsPerReadClock                      : INTEGER   :=  8;
constant   DatabitsPerMask                           : INTEGER   :=  8;
constant   no_of_cs                                  : INTEGER   :=  1;
constant   data_mask                                 : INTEGER   :=  1;
constant   mask_disable                              : INTEGER   :=  0;
constant   RESET                                     : INTEGER   :=  0;
constant   dimm                                      : INTEGER   :=  0;
constant   comp                                      : INTEGER   :=  1;
constant   cke_width                                 : INTEGER   :=  1;
constant   registered                                : INTEGER   :=  0;
constant   unbuffered                                : INTEGER   :=  1;
constant   col_ap_width                              : INTEGER   :=  11;
constant   paramWidth                                : INTEGER   :=  1;
constant   into2                                     : INTEGER   :=  2;
constant   write_pipe_itr                            : INTEGER   :=  1;
constant   tb_enable                                 : INTEGER   :=  1;
constant   tb_disable                                : INTEGER   :=  0;
constant   dcm_enable                                : INTEGER   :=  1;
constant   dcm_disable                               : INTEGER   :=  0;
constant   write_pipeline                            : INTEGER   :=  4;
constant   top_bottom                                : INTEGER   :=   0;
constant   left_right                                : INTEGER   :=   1;
constant   foundation_ise                            : INTEGER   :=  1;
constant   Data8PerReadEnable                        : INTEGER   :=  0;
constant   Data4PerReadEnable                        : INTEGER   :=  1;
constant   burst_length                             		: std_logic_vector(2 downto 0) := "010";
constant   burst_type                               		: std_logic :=  '0';
constant   cas_latency_value                        		: std_logic_vector(2 downto 0) := "011";
constant   Operating_mode                           		: std_logic_vector(4 downto 0) := "00000";
constant   load_mode_register                        : std_logic_vector(12 downto 0) := "0000000110010";


constant   chip_address                              : INTEGER   :=  1;
constant   rcd_count_value                           : std_logic_vector(2 downto 0) := "001";
constant   ras_count_value                           : std_logic_vector(3 downto 0) := "0101";
constant   mrd_count_value                           : std_logic := '0';
constant   rp_count_value                            : std_logic_vector(2 downto 0) := "001";
constant   rfc_count_value                           : std_logic_vector(5 downto 0) := "001001";
constant   twr_count_value                           : std_logic_vector(2 downto 0) := "110";
constant   twtr_count_value                      : std_logic_vector(2 downto 0) := "100";
constant   max_ref_width                             : INTEGER   :=  11;
constant   max_ref_cnt                     : std_logic_vector(10 downto 0) := "10000000001";

constant RFC_COUNTER      : std_logic_vector(4 downto 0)   := "11001";       -- Depends on the memory selected 
constant WRITE_RECOVERY_VAL  : std_logic_vector(2 downto 0)    := "100";   -- Write Recovery Value 

end xst_vhdl_bl4cl3_parameters_0  ;
