
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

--library synplify;
--use synplify.attributes.all;

--
-- pragma translate_off
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on
  
--//#############################################################################//
--//         Internal dqs delay structure for ddr sdram controller               //                          
--//#############################################################################//



entity  xst_vhdl_bl4cl3_tap_dly_0 is 
              port (
		    clk    : in std_logic;
		    reset  : in std_logic; 	
		    tapIn : in std_logic;
		    flop2  : out std_logic_vector(31 downto 0)
		  );
end xst_vhdl_bl4cl3_tap_dly_0 ;

architecture arc_tap_dly of xst_vhdl_bl4cl3_tap_dly_0 is

component LUT4
   generic(
      INIT                           :  bit_vector(15 downto 0) := x"0000" );
   port(
      O                              :	out   STD_ULOGIC;
      I0                             :	in    STD_ULOGIC;
      I1                             :	in    STD_ULOGIC;
      I2                             :	in    STD_ULOGIC;
      I3                             :	in    STD_ULOGIC
      );
end component;

--attribute syn_black_box of LUT4 : component is true;
--attribute xc_map of LUT4 : component is "lut";	


component FDR
    port(
      Q                              : out STD_LOGIC;
      C                              : in STD_LOGIC;
      D                              : in STD_LOGIC;
	R					 : in STD_LOGIC 	
      );
  end component;


  
signal tap        : std_logic_vector(31 downto 0);
signal flop1      : std_logic_vector(31 downto 0);
signal high       : std_logic;
signal low        : std_logic;



--attribute preserve_signal of         tap 	: signal is true;
--attribute preserve_signal of         flop1 	: signal is true;


--signal flop2n_0 :  std_logic;
--signal flop2n_1 :  std_logic;
--signal flop2n_2 :  std_logic;
--signal flop2n_3 :  std_logic;
--signal flop2n_4 :  std_logic;
--signal flop2n_5 :  std_logic;
--signal flop2n_6 :  std_logic;
--signal flop2n_7 :  std_logic;
--signal flop2n_8 :  std_logic;
--signal flop2n_9 :  std_logic;
--signal flop2n_10:  std_logic;
--signal flop2n_11:  std_logic;
--signal flop2n_12:  std_logic;
--signal flop2n_13:  std_logic;
--signal flop2n_14:  std_logic;
--signal flop2n_15:  std_logic;
--signal flop2n_16 :  std_logic;
--signal flop2n_17 :  std_logic;
--signal flop2n_18 :  std_logic;
--signal flop2n_19 :  std_logic;
--signal flop2n_20 :  std_logic;
--signal flop2n_21:  std_logic;
--signal flop2n_22:  std_logic;
--signal flop2n_23:  std_logic;
--signal flop2n_24:  std_logic;
--signal flop2n_25:  std_logic;
--signal flop2n_26:  std_logic;
--signal flop2n_27:  std_logic;
--signal flop2n_28:  std_logic;
--signal flop2n_29:  std_logic;
--signal flop2n_30:  std_logic;
--signal flop2n_31:  std_logic;

--attribute preserve_signal of flop2n_0  :  signal is true;
--attribute preserve_signal of flop2n_1  :  signal is true;
--attribute preserve_signal of flop2n_2  :  signal is true;
--attribute preserve_signal of flop2n_3  :  signal is true;
--attribute preserve_signal of flop2n_4  :  signal is true;
--attribute preserve_signal of flop2n_5  :  signal is true;
--attribute preserve_signal of flop2n_6  :  signal is true;
--attribute preserve_signal of flop2n_7  :  signal is true;
--attribute preserve_signal of flop2n_8  :  signal is true;
--attribute preserve_signal of flop2n_9  :  signal is true;
--attribute preserve_signal of flop2n_10 :  signal is true;
--attribute preserve_signal of flop2n_11 :  signal is true;
--attribute preserve_signal of flop2n_12 :  signal is true;
--attribute preserve_signal of flop2n_13 :  signal is true;
--attribute preserve_signal of flop2n_14 :  signal is true;
--attribute preserve_signal of flop2n_15 :  signal is true;
--attribute preserve_signal of flop2n_16 :  signal is true;
--attribute preserve_signal of flop2n_17 :  signal is true;
--attribute preserve_signal of flop2n_18 :  signal is true;
--attribute preserve_signal of flop2n_19 :  signal is true;
--attribute preserve_signal of flop2n_20 :  signal is true;
--attribute preserve_signal of flop2n_21 :  signal is true;
--attribute preserve_signal of flop2n_22 :  signal is true;
--attribute preserve_signal of flop2n_23 :  signal is true;
--attribute preserve_signal of flop2n_24 :  signal is true;
--attribute preserve_signal of flop2n_25 :  signal is true;
--attribute preserve_signal of flop2n_26 :  signal is true;
--attribute preserve_signal of flop2n_27 :  signal is true;
--attribute preserve_signal of flop2n_28 :  signal is true;
--attribute preserve_signal of flop2n_29 :  signal is true;
--attribute preserve_signal of flop2n_30 :  signal is true;
--attribute preserve_signal of flop2n_31 :  signal is true;


signal flop2i_0 :  std_logic;
signal flop2i_1 :  std_logic;
signal flop2i_2 :  std_logic;
signal flop2i_3 :  std_logic;
signal flop2i_4 :  std_logic;
signal flop2i_5 :  std_logic;
signal flop2i_6 :  std_logic;
signal flop2i_7 :  std_logic;
signal flop2i_8 :  std_logic;
signal flop2i_9 :  std_logic;
signal flop2i_10:  std_logic;
signal flop2i_11:  std_logic;
signal flop2i_12:  std_logic;
signal flop2i_13:  std_logic;
signal flop2i_14:  std_logic;
signal flop2i_15:  std_logic;
signal flop2i_16 :  std_logic;
signal flop2i_17 :  std_logic;
signal flop2i_18 :  std_logic;
signal flop2i_19 :  std_logic;
signal flop2i_20 :  std_logic;
signal flop2i_21:  std_logic;
signal flop2i_22:  std_logic;
signal flop2i_23:  std_logic;
signal flop2i_24:  std_logic;
signal flop2i_25:  std_logic;
signal flop2i_26:  std_logic;
signal flop2i_27:  std_logic;
signal flop2i_28:  std_logic;
signal flop2i_29:  std_logic;
signal flop2i_30:  std_logic;


begin

high <= '1';   
low  <= '0';

l0 :  LUT4  generic map (INIT => x"e2e2")  
port map   ( I0 => high, 
             I1 => tapIn, 
             I2 => low, 
             I3 => high, 
             O  => tap(0)
            );

l1 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(0), 
              I2 => low, 
              I3 => high, 
              O  => tap(1) 
             );
l2 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(1), 
              I2 => low, 
              I3 => high, 
              O  => tap(2) 
             );
l3 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(2), 
              I2 => low, 
              I3 => high, 
              O  => tap(3) 
             );
l4 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(3), 
              I2 => low, 
              I3 => high, 
              O  => tap(4) 
             );
l5 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(4), 
              I2 => low, 
              I3 => high, 
              O  => tap(5) 
             );
l6 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(5), 
              I2 => low, 
              I3 => high, 
              O  => tap(6) 
             );
l7 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(6), 
              I2 => low, 
              I3 => high, 
              O  => tap(7) 
             );
l8 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(7), 
              I2 => low, 
              I3 => high, 
              O  => tap(8) 
             );
l9 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(8), 
              I2 => low, 
              I3 => high, 
              O  => tap(9) 
             );
l10 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(9), 
              I2 => low, 
              I3 => high, 
              O  => tap(10) 
             );
l11 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(10), 
              I2 => low, 
              I3 => high, 
              O  => tap(11) 
             );
l12 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(11), 
              I2 => low, 
              I3 => high, 
              O  => tap(12) 
             );
l13 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(12), 
              I2 => low, 
              I3 => high, 
              O  => tap(13) 
             );
l14 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(13), 
              I2 => low, 
              I3 => high, 
              O  => tap(14) 
             );
l15 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(14), 
              I2 => low, 
              I3 => high, 
              O  => tap(15) 
             );
l16 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(15), 
              I2 => low, 
              I3 => high, 
              O  => tap(16) 
             );
l17 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(16), 
              I2 => low, 
              I3 => high, 
              O  => tap(17) 
             );
l18 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(17), 
              I2 => low, 
              I3 => high, 
              O  => tap(18) 
             );
l19 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(18), 
              I2 => low, 
              I3 => high, 
              O  => tap(19) 
             );
l20 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(19), 
              I2 => low, 
              I3 => high, 
              O  => tap(20) 
             );
l21 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(20), 
              I2 => low, 
              I3 => high, 
              O  => tap(21) 
             );
l22 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(21), 
              I2 => low, 
              I3 => high, 
              O  => tap(22) 
             );
l23 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(22), 
              I2 => low, 
              I3 => high, 
              O  => tap(23) 
             );
l24 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(23), 
              I2 => low, 
              I3 => high, 
              O  => tap(24) 
             );
l25 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(24), 
              I2 => low, 
              I3 => high, 
              O  => tap(25) 
             );
l26 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(25), 
              I2 => low, 
              I3 => high, 
              O  => tap(26) 
             );
l27 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(26), 
              I2 => low, 
              I3 => high, 
              O  => tap(27) 
             );
l28 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(27), 
              I2 => low, 
              I3 => high, 
              O  => tap(28) 
             );
l29 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(28), 
              I2 => low, 
              I3 => high, 
              O  => tap(29) 
             );
l30 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(29), 
              I2 => low, 
              I3 => high, 
              O  => tap(30) 
             );
l31 :  LUT4  generic map (INIT => x"e2e2")    
port map     ( 
              I0 => high, 
              I1 => tap(30), 
              I2 => low, 
              I3 => high, 
              O  => tap(31) 
             );


r0  : FDR port map  (
			   Q => flop1(0),
			   C => clk,
			   D => tap(0),
			   R => reset 	
			  );

r1  : FDR port map  (
			   Q => flop1(1),
			   C => clk,
			   D => tap(1),
			   R => reset 	
			  );


r2  : FDR port map  (
			   Q => flop1(2),
			   C => clk,
			   D => tap(2),
			   R => reset 	
			  );

r3  : FDR port map  (
			   Q => flop1(3),
			   C => clk,
			   D => tap(3),
			   R => reset 	
			  );

r4  : FDR port map  (
			   Q => flop1(4),
			   C => clk,
			   D => tap(4),
			   R => reset 	
			  );

r5  : FDR port map  (
			   Q => flop1(5),
			   C => clk,
			   D => tap(5),
			   R => reset 	
			  );

r6  : FDR port map  (
			   Q => flop1(6),
			   C => clk,
			   D => tap(6),
			   R => reset 	
			  );

r7  : FDR port map  (
			   Q => flop1(7),
			   C => clk,
			   D => tap(7),
			   R => reset 	
			  );

r8  : FDR port map  (
			   Q => flop1(8),
			   C => clk,
			   D => tap(8),
			   R => reset 	
			  );

r9  : FDR port map  (
			   Q => flop1(9),
			   C => clk,
			   D => tap(9),
			   R => reset 	
			  );

r10  : FDR port map  (
			   Q => flop1(10),
			   C => clk,
			   D => tap(10),
			   R => reset 	
			  );

r11  : FDR port map  (
			   Q => flop1(11),
			   C => clk,
			   D => tap(11),
			   R => reset 	
			  );

r12  : FDR port map  (
			   Q => flop1(12),
			   C => clk,
			   D => tap(12),
			   R => reset 	
			  );

r13  : FDR port map  (
			   Q => flop1(13),
			   C => clk,
			   D => tap(13),
			   R => reset 	
			  );

r14  : FDR port map  (
			   Q => flop1(14),
			   C => clk,
			   D => tap(14),
			   R => reset 	
			  );

r15  : FDR port map  (
			   Q => flop1(15),
			   C => clk,
			   D => tap(15),
			   R => reset 	
			  );

r16  : FDR port map  (
			   Q => flop1(16),
			   C => clk,
			   D => tap(16),
			   R => reset 	
			  );

r17  : FDR port map  (
			   Q => flop1(17),
			   C => clk,
			   D => tap(17),
			   R => reset 	
			  );

r18  : FDR port map  (
			   Q => flop1(18),
			   C => clk,
			   D => tap(18),
			   R => reset 	
			  );

r19  : FDR port map  (
			   Q => flop1(19),
			   C => clk,
			   D => tap(19),
			   R => reset 	
			  );

r20  : FDR port map  (
			   Q => flop1(20),
			   C => clk,
			   D => tap(20),
			   R => reset 	
			  );

r21  : FDR port map  (
			   Q => flop1(21),
			   C => clk,
			   D => tap(21),
			   R => reset 	
			  );

r22  : FDR port map  (
			   Q => flop1(22),
			   C => clk,
			   D => tap(22),
			   R => reset 	
			  );

r23  : FDR port map  (
			   Q => flop1(23),
			   C => clk,
			   D => tap(23),
			   R => reset 	
			  );

r24  : FDR port map  (
			   Q => flop1(24),
			   C => clk,
			   D => tap(24),
			   R => reset 	
			  );

r25  : FDR port map  (
			   Q => flop1(25),
			   C => clk,
			   D => tap(25),
			   R => reset 	
			  );

r26  : FDR port map  (
			   Q => flop1(26),
			   C => clk,
			   D => tap(26),
			   R => reset 	
			  );

r27  : FDR port map  (
			   Q => flop1(27),
			   C => clk,
			   D => tap(27),
			   R => reset 	
			  );

r28  : FDR port map  (
			   Q => flop1(28),
			   C => clk,
			   D => tap(28),
			   R => reset 	
			  );

r29  : FDR port map  (
			   Q => flop1(29),
			   C => clk,
			   D => tap(29),
			   R => reset 	
			  );

r30  : FDR port map  (
			   Q => flop1(30),
			   C => clk,
			   D => tap(30),
			   R => reset 	
			  );

r31  : FDR port map  (
			   Q => flop1(31),
			   C => clk,
			   D => tap(31),
			   R => reset 	
			  );



flop2i_0  <= flop1(0)  xnor flop1(1);
flop2i_1  <= flop1(1)  xnor flop1(2);
flop2i_2  <= flop1(2)  xnor flop1(3);
flop2i_3  <= flop1(3)  xnor flop1(4);
flop2i_4  <= flop1(4)  xnor flop1(5);
flop2i_5  <= flop1(5)  xnor flop1(6);
flop2i_6  <= flop1(6)  xnor flop1(7);
flop2i_7  <= flop1(7)  xnor flop1(8);
flop2i_8  <= flop1(8)  xnor flop1(9);
flop2i_9  <= flop1(9)  xnor flop1(10);
flop2i_10 <= flop1(10) xnor flop1(11);
flop2i_11 <= flop1(11) xnor flop1(12);
flop2i_12 <= flop1(12) xnor flop1(13);
flop2i_13 <= flop1(13) xnor flop1(14);
flop2i_14 <= flop1(14) xnor flop1(15);
flop2i_15 <= flop1(15) xnor flop1(16);
flop2i_16 <= flop1(16) xnor flop1(17);
flop2i_17 <= flop1(17) xnor flop1(18);
flop2i_18 <= flop1(18) xnor flop1(19);
flop2i_19 <= flop1(19) xnor flop1(20);
flop2i_20 <= flop1(20) xnor flop1(21);
flop2i_21 <= flop1(21) xnor flop1(22);
flop2i_22 <= flop1(22) xnor flop1(23);
flop2i_23 <= flop1(23) xnor flop1(24);
flop2i_24 <= flop1(24) xnor flop1(25);
flop2i_25 <= flop1(25) xnor flop1(26);
flop2i_26 <= flop1(26) xnor flop1(27);
flop2i_27 <= flop1(27) xnor flop1(28);
flop2i_28 <= flop1(28) xnor flop1(29);
flop2i_29 <= flop1(29) xnor flop1(30);
flop2i_30 <= flop1(30) xnor flop1(31);

u0  : FDR port map  (
			  -- Q => flop2n_0,
				Q => flop2(0),
			   C => clk,
			   D => flop2i_0,
			   R => reset 	
			  );

u1  : FDR port map  (
			  -- Q => flop2n_1,
				Q => flop2(1),
			   C => clk,
			   D => flop2i_1,
			   R => reset 	
			  );


u2  : FDR port map  (
			  -- Q => flop2n_2,
				Q => flop2(2),
			   C => clk,
			   D => flop2i_2,
			   R => reset 	
			  );


u3  : FDR port map  (
			  -- Q => flop2n_3,
				Q => flop2(3),
			   C => clk,
			   D => flop2i_3,
			   R => reset 	
			  );


u4  : FDR port map  (
			  -- Q => flop2n_4,
				Q => flop2(4),
			   C => clk,
			   D => flop2i_4,
			   R => reset 	
			  );


u5  : FDR port map  (
			  -- Q => flop2n_5,
				Q => flop2(5),
			   C => clk,
			   D => flop2i_5,
			   R => reset 	
			  );

u6  : FDR port map  (
			  -- Q => flop2n_6,
				Q => flop2(6),
			   C => clk,
			   D => flop2i_6,
			   R => reset 	
			  );

u7  : FDR port map  (
			  -- Q => flop2n_7,
				Q => flop2(7),
			   C => clk,
			   D => flop2i_7,
			   R => reset 	
			  );

u8  : FDR port map  (
			  -- Q => flop2n_8,
				Q => flop2(8),
			   C => clk,
			   D => flop2i_8,
			   R => reset 	
			  );

u9  : FDR port map  (
			  -- Q => flop2n_9,
				Q => flop2(9),
			   C => clk,
			   D => flop2i_9,
			   R => reset 	
			  );

u10  : FDR port map  (
			  -- Q => flop2n_10,
				Q => flop2(10),
			   C => clk,
			   D => flop2i_10,
			   R => reset 	
			  );

u11  : FDR port map  (
			  -- Q => flop2n_11,
				Q => flop2(11),
			   C => clk,
			   D => flop2i_11,
			   R => reset 	
			  );

u12  : FDR port map  (
			  -- Q => flop2n_12,
				Q => flop2(12),
			   C => clk,
			   D => flop2i_12,
			   R => reset 	
			  );

u13  : FDR port map  (
			  -- Q => flop2n_13,
				Q => flop2(13),
			   C => clk,
			   D => flop2i_13,
			   R => reset 	
			  );

u14  : FDR port map  (
			  -- Q => flop2n_14,
				Q => flop2(14),
			   C => clk,
			   D => flop2i_14,
			   R => reset 	
			  );

u15  : FDR port map  (
			  -- Q => flop2n_15,
				Q => flop2(15),
			   C => clk,
			   D => flop2i_15,
			   R => reset 	
			  );

u16  : FDR port map  (
			  -- Q => flop2n_16,
				Q => flop2(16),
			   C => clk,
			   D => flop2i_16,
			   R => reset 	
			  );

u17  : FDR port map  (
			  -- Q => flop2n_17,
				Q => flop2(17),
			   C => clk,
			   D => flop2i_17,
			   R => reset 	
			  );

u18  : FDR port map  (
			  -- Q => flop2n_18,
				Q => flop2(18),
			   C => clk,
			   D => flop2i_18,
			   R => reset 	
			  );

u19  : FDR port map  (
			  -- Q => flop2n_19,
				Q => flop2(19),
			   C => clk,
			   D => flop2i_19,
			   R => reset 	
			  );

u20  : FDR port map  (
			  -- Q => flop2n_20,
				Q => flop2(20),
			   C => clk,
			   D => flop2i_20,
			   R => reset 	
			  );

u21  : FDR port map  (
			  -- Q => flop2n_21,
				Q => flop2(21),
			   C => clk,
			   D => flop2i_21,
			   R => reset 	
			  );


u22  : FDR port map  (
			  -- Q => flop2n_22,
				Q => flop2(22),
			   C => clk,
			   D => flop2i_22,
			   R => reset 	
			  );

u23  : FDR port map  (
			  -- Q => flop2n_23,
				Q => flop2(23),
			   C => clk,
			   D => flop2i_23,
			   R => reset 	
			  );


u24  : FDR port map  (
			  -- Q => flop2n_24,
				Q => flop2(24),
			   C => clk,
			   D => flop2i_24,
			   R => reset 	
			  );

u25  : FDR port map  (
			  -- Q => flop2n_25,
				Q => flop2(25),
			   C => clk,
			   D => flop2i_25,
			   R => reset 	
			  );

u26  : FDR port map  (
			  -- Q => flop2n_26,
				Q => flop2(26),
			   C => clk,
			   D => flop2i_26,
			   R => reset 	
			  );

u27  : FDR port map  (
			  -- Q => flop2n_27,
				Q => flop2(27),
			   C => clk,
			   D => flop2i_27,
			   R => reset 	
			  );


u28  : FDR port map  (
			  -- Q => flop2n_28,
				Q => flop2(28),
			   C => clk,
			   D => flop2i_28,
			   R => reset 	
			  );

u29  : FDR port map  (
			  -- Q => flop2n_29,
				Q => flop2(29),
			   C => clk,
			   D => flop2i_29,
			   R => reset 	
			  );

u30  : FDR port map  (
			  -- Q => flop2n_30,
				Q => flop2(30),
			   C => clk,
			   D => flop2i_30,
			   R => reset 	
			  );

u31  : FDR port map  (
			 --  Q => flop2n_31,
			   Q => flop2(31),
			   C => clk,
			   D => flop1(31),
			   R => reset 	
			  );


--flop2(0)  <= not flop2n_0;
--flop2(1)  <= not flop2n_1;
--flop2(2)  <= not flop2n_2;
--flop2(3)  <= not flop2n_3;
--flop2(4)  <= not flop2n_4;
--flop2(5)  <= not flop2n_5;
--flop2(6)  <= not flop2n_6;
--flop2(7)  <= not flop2n_7;
--flop2(8)  <= not flop2n_8;
--flop2(9)  <= not flop2n_9;
--flop2(10) <= not flop2n_10;
--flop2(11) <= not flop2n_11;
--flop2(12) <= not flop2n_12;
--flop2(13) <= not flop2n_13;
--flop2(14) <= not flop2n_14;
--flop2(15) <= not flop2n_15;
--flop2(16) <= not flop2n_16;
--flop2(17) <= not flop2n_17;
--flop2(18) <= not flop2n_18;
--flop2(19) <= not flop2n_19;
--flop2(20) <= not flop2n_20;
--flop2(21) <= not flop2n_21;
--flop2(22) <= not flop2n_22;
--flop2(23) <= not flop2n_23;
--flop2(24) <= not flop2n_24;
--flop2(25) <= not flop2n_25;
--flop2(26) <= not flop2n_26;
--flop2(27) <= not flop2n_27;
--flop2(28) <= not flop2n_28;
--flop2(29) <= not flop2n_29;
--flop2(30) <= not flop2n_30;
--flop2(31) <= not flop2n_31;

end arc_tap_dly;
