`include "C:/Designs/Spartan-3E_Starter_Kit/Test_Designs/DDR_MIG/s3e_starter_revD_mig_ddr/xst_vhdl_bl4cl3/xst_vhdl_bl4cl3/Modelsim/xst_vlog_bl4cl3_parameters_0.v"
                                                                                                                        
`timescale 1ps / 1ps
//`timescale 1ns / 100ps



module ddr1_test_tb;

parameter CLOCK_PERIOD = 7500;	//S3E_STARTER
parameter HALF_CLK_PERIOD = 3750; //S3E_STARTER

reg clk    ;
wire clkb   ;
reg rst    ;
wire [`clk_width-1:0]ddr_clk;
wire [`clk_width-1:0]ddr_clkb;
wire [`data_strobe_width-1:0]ddr_dqs_fpga   ;
wire [`data_strobe_width-1:0]ddr_dqs_sdram  ;
wire [`data_width-1:0] ddr_dq_fpga   ;
wire [`data_width-1:0] ddr_dq_sdram  ;
wire ddr_cke           ;
wire ddr_csb           ;
wire ddr_rasb          ;
wire ddr_casb          ;
wire ddr_web           ;
wire [`data_mask_width-1:0]ddr_dm;
wire [1:0] ddr_ba         ;
wire [`row_address-1:0] ddr_address   ;

wire [2:0]CMD        ;
reg  enable_o          ;
reg  enable            ;
wire led_error_output1 ;
wire rst_dqs_div       ;
wire rst_dqs_div1;
   
wire gnd               ;
wire tmp               ;
wire tmp1              ;
//S3E_STARTER wire [(2*`data_width)-1:0] read_data_out ;
//S3E_STARTER wire [(2*`data_width)-1:0] lfsr_data_out ;                                                
wire data_valid ; //S3E_STARTER
                                                  
assign CMD = {ddr_rasb, ddr_casb , ddr_web};        
assign dip1 = 1'b1;     
assign dip2 = 1'b1;                                                                       
assign clkb = ~ clk;
assign gnd = 1'b0;

   assign #4000 rst_dqs_div1 =  rst_dqs_div;
    
always @(posedge clk)
  begin
     if (rst) //S3E_STARTER changed reset polarity
       begin
	  enable_o <= 1'b0;
          enable <= 1'b0;
       end
    else if(CMD == 3'b100) // write
       enable_o <= 1'b0;
     else if(CMD == 3'b101) // read
       enable_o <= 1'b1;
     else
       enable_o <= enable_o;

     enable <= enable_o;
      
  end 
     

// During a READ

   assign #100 ddr_dqs_fpga  =  (enable) ?  ddr_dqs_sdram : 8'bz;
   assign #100 ddr_dq_fpga =  (enable) ? ddr_dq_sdram : 64'bz;
                 

// During a WRITE

   assign #50 ddr_dqs_sdram =  (!enable_o) ? ddr_dqs_fpga : 8'bz;
   assign ddr_dq_sdram = (!enable_o) ? ddr_dq_fpga : 64'bz;
  


xst_vhdl_bl4cl3   xst_vhdl_bl4cl3_inst  (
               .reset			(rst),  //S3E_STARTER was .reset_in
					.SYS_CLK			(clk),
					//S3E_STARTER .SYS_CLKb			(clkb),
					//S3E_STARTER .cntrl0_rst_dqs_div_in		(rst_dqs_div),
					//S3E_STARTER .cntrl0_rst_dqs_div_out		(rst_dqs_div),
					.cntrl0_rst_dqs_div		(rst_dqs_div),
					.cntrl0_DDR_CAS_N			(ddr_casb),
					.cntrl0_DDR_CKE			(ddr_cke),
					.cntrl0_led_error_output1	(led_error_output1),
					.cntrl0_DDR_CK		(ddr_clk), 
					.cntrl0_DDR_CK_N		(ddr_clkb), 
					.cntrl0_DDR_CS_N		(ddr_csb),
					.cntrl0_DDR_RAS_N		(ddr_rasb),
					.cntrl0_DDR_WE_N		(ddr_web),
					.cntrl0_DDR_A		(ddr_address),
					.cntrl0_DDR_DQS		(ddr_dqs_fpga),
					.cntrl0_DDR_BA		(ddr_ba),
					.cntrl0_DDR_DM		(ddr_dm),
					.cntrl0_DDR_DQ		(ddr_dq_fpga),
					.DATA_VALID (data_valid) //S3E_STARTER
					);

MT46V32M16TG6T mt46v32m16_inst (
                                 .Dq    ( ddr_dq_sdram[15:0]),
                                 .Dqs   ( ddr_dqs_sdram[1:0]),
                                 .Addr  ( ddr_address),
                                 .Ba    ( ddr_ba),
                                 .Clk   ( ddr_clk[0]),
                                 .Clk_n ( ddr_clkb[0]),
                                 .Cke   ( ddr_cke),
                                 .Cs_n  ( ddr_csb),
                                 .Ras_n ( ddr_rasb),
                                 .Cas_n ( ddr_casb),
                                 .We_n  ( ddr_web),
                                 .Dm    ( ddr_dm[1:0])
                                 );

//Clock Generation

initial clk <= 1'b0;
always #3750 clk <=  ~clk;


//  RESET Generation

initial
  begin
     rst <= 1'b1; //S3E_STARTER changed polarity
     #25000 rst <= 1'b0; //S3E_STARTER changed polarity
  end



  

endmodule 
    

                                      
