///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// All Rights Reserved
///////////////////////////////////////////////////////////////////////////////
// ____ ____
// / /\/ /
// /___/ \ / Vendor: Xilinx
// \ \ \/ Version  : 1.5
// \ \ Application : MIG
// / / Filename    : xst_vlog_bl2cl2.v
// /___/ /\ 
// \ \ / \
// \___\/\___\
//
//Design Name : mem_interface_top
//Description : This module contains the instantiations for 
//			-infrastructure_top and
//                -main modules
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

module xst_vlog_bl2cl2 
     (
	cntrl0_DDR_DQ,
cntrl0_DDR_A,
cntrl0_DDR_BA,
cntrl0_DDR_CK,
cntrl0_DDR_CK_N,
cntrl0_DDR_CKE,
cntrl0_DDR_CS_N,
cntrl0_DDR_RAS_N,
cntrl0_DDR_CAS_N,
cntrl0_DDR_WE_N,
cntrl0_DDR_DM,
//S3E_STARTER cntrl0_rst_dqs_div_in,
//S3E_STARTER cntrl0_rst_dqs_div_out,
cntrl0_rst_dqs_div, //S3E_STARTER
//S3E_STARTER SYS_CLKb,
SYS_CLK,
cntrl0_led_error_output1,
//S3E_STARTER reset_in,
reset, //S3E_STARTER
DATA_VALID, //S3E_STARTER
cntrl0_DDR_DQS
      ); 
//Input/Output declarations


inout [15:0] cntrl0_DDR_DQ;
output [12:0] cntrl0_DDR_A;
output [1:0] cntrl0_DDR_BA;
output  cntrl0_DDR_CK;
output  cntrl0_DDR_CK_N;
output  cntrl0_DDR_CKE;
output  cntrl0_DDR_CS_N;
output  cntrl0_DDR_RAS_N;
output  cntrl0_DDR_CAS_N;
output  cntrl0_DDR_WE_N;
output [1:0] cntrl0_DDR_DM;
//S3E_STARTER input  cntrl0_rst_dqs_div_in;
//S3E_STARTER output  cntrl0_rst_dqs_div_out;
inout cntrl0_rst_dqs_div; //S3E_STARTER
//S3E_STARTER input  SYS_CLKb;
input  SYS_CLK;
output  cntrl0_led_error_output1;
//S3E_STARTER input  reset_in;
input reset; //S3E_STARTER
inout [1:0] cntrl0_DDR_DQS;
output DATA_VALID;

wire wait_200us;
wire clk_int;
wire clk90_int;
//wire clk180_int;
//wire clk270_int;

wire sys_rst;
wire sys_rst90;
wire sys_rst180;
wire sys_rst270;
wire [4:0] delay_sel_tb;
wire [4:0] delay_sel_rl; 
wire clk_out;
wire clk90_out;

wire reset_in; //S3E_STARTER
assign reset_in = ~reset; //S3E_STARTER

assign    clk_out = clk_int;  // for no tb
assign    clk90_out = clk90_int;  // for no tb

//assign    clk180_int = ~clk_int;
//assign    clk270_int = ~clk90_int;

wire cntrl0_rst_dqs_div; //S3E_STARTER




//----  Component instantiations  ---- 

xst_vlog_bl2cl2_main_0 main_00(
					.wait_200us	(wait_200us),
					//.reset_in	(reset_in),	   
					.clk_int	(clk_int),
					.clk90_int	(clk90_int),
					//.clk180_int	(clk180_int),
					//.clk270_int	(clk270_int),
					.sys_rst_val	(sys_rst),
					.sys_rst90_val	(sys_rst90),
					.sys_rst180_val	(sys_rst180),
					.sys_rst270_val	(sys_rst270),
					.delay_sel_val	(delay_sel_rl), 

					.DDR_DQ	(cntrl0_DDR_DQ),
.DDR_A	(cntrl0_DDR_A),
.DDR_BA	(cntrl0_DDR_BA),
.DDR_CK	(cntrl0_DDR_CK),
.DDR_CK_N	(cntrl0_DDR_CK_N),
.DDR_CKE	(cntrl0_DDR_CKE),
.DDR_CS_N	(cntrl0_DDR_CS_N),
.DDR_RAS_N	(cntrl0_DDR_RAS_N),
.DDR_CAS_N	(cntrl0_DDR_CAS_N),
.DDR_WE_N	(cntrl0_DDR_WE_N),
.DDR_DM	(cntrl0_DDR_DM),
.rst_dqs_div_in	(cntrl0_rst_dqs_div),  //S3E_STARTER
.rst_dqs_div_out	(cntrl0_rst_dqs_div),  //S3E_STARTER
.led_error_output1	(cntrl0_led_error_output1),
.DDR_DQS	(cntrl0_DDR_DQS),
.data_valid_out1 (DATA_VALID) //S3E_STARTER
);


xst_vlog_bl2cl2_infrastructure_top infrastructure_top0
                                       (
//S3E_STARTER				       .SYS_CLKb	(SYS_CLKb),
.SYS_CLK	(SYS_CLK),
.reset_in	(reset_in),	   

					.wait_200us	(wait_200us),
					.delay_sel_val1_val_tb(delay_sel_tb),
					.delay_sel_val1_val_rl(delay_sel_rl), 
					.sys_rst_val	(sys_rst),
					.sys_rst90_val	(sys_rst90),
					.clk_int_val	(clk_int),
					.clk90_int_val	(clk90_int),
					.sys_rst180_val	(sys_rst180),
					.sys_rst270_val	(sys_rst270)

                                       );

endmodule
