///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// All Rights Reserved
///////////////////////////////////////////////////////////////////////////////
// ____ ____
// / /\/ /
// /___/ \ / Vendor: Xilinx
// \ \ \/ Version: 1.5
// \ \ Application : MIG
// / / Filename: cal_top.v
// /___/ /\ 
// \ \ / \
// \___\/\___\
//
//Design Name : cal_top
//Description : It contains the instantiations for cal_ctl and tap_dly
///////////////////////////////////////////////////////////////////////////////


`timescale 1ns/100ps
module xst_vlog_bl2cl2_cal_top(clk0,
               clk0dcmlock,
               reset,
               tapForDqs_rl,
               tapForDqs_tb);


   input clk0;
   input clk0dcmlock;
   input reset;

 output [4:0]      tapForDqs_rl;
  output [4:0]      tapForDqs_tb;
   

   wire [31:0] flop2_val;
   reg  fpga_rst;


   always@(posedge clk0)begin
      fpga_rst <= ~(reset && clk0dcmlock);
   end


   xst_vlog_bl2cl2_cal_ctl_0 cal_ctl0 (.clk(clk0), .reset(fpga_rst), .flop2(flop2_val), .tapForDqs_tb(tapForDqs_tb),
					.tapForDqs_rl(tapForDqs_rl));
   xst_vlog_bl2cl2_tap_dly_0 tap_dly0 (.clk(clk0), .reset(fpga_rst), .tapIn(clk0), .flop2(flop2_val));

endmodule 
   
      
