///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// All Rights Reserved
///////////////////////////////////////////////////////////////////////////////
// ____ ____
// / /\/ /
// /___/ \ / Vendor: Xilinx
// \ \ \/ Version  : 1.5
// \ \ Application : MIG
// / / Filename    : fifo_0_wr_en.v
// /___/ /\ 
// \ \ / \
// \___\/\___\
//
//Design Name : fifo_0_wr_en
//Description : It generates the write enable signal for the fifos
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
module xst_vlog_bl2cl2_fifo_0_wr_en_0 ( clk,
                      reset,
                      din,
                      rst_dqs_delay_n,
                      dout);

   input clk;
   input reset;
   input din;
   output rst_dqs_delay_n;
   output dout;


   wire din_delay;
  // wire din_delay_r2;
    

   parameter TIE_HIGH = 1'b1;

   assign rst_dqs_delay_n = ~din_delay; 
   //assign dout = (din | (din_delay & din_delay_r2));
   assign dout = (din | (din_delay));
   

   FDCE delay_ff (.Q(din_delay), .C(clk), .CE(TIE_HIGH), .CLR (reset), .D(din));
  // FDCE delay_ff2 (.Q(din_delay_r2), .C(~clk), .CE(TIE_HIGH), .CLR (reset), .D(din_delay));

endmodule 

