///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// All Rights Reserved
///////////////////////////////////////////////////////////////////////////////
// ____ ____
// / /\/ /
// /___/ \ / Vendor: Xilinx
// \ \ \/ Version  : 1.5
// \ \ Application : MIG
// / / Filename    : fifo_1_wr_en.v
// /___/ /\ 
// \ \ / \
// \___\/\___\
//
//Design Name : fifo_1_wr_en.v
//Description : It generates the write enable signal for the fifos
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
module xst_vlog_bl2cl2_fifo_1_wr_en_0 ( clk,
                      rst_dqs_delay_n,
                      reset,
                      din,
                      dout);

   input clk;
   input rst_dqs_delay_n;
   input reset;
   input din;
   output dout;


   wire din_delay;
   wire din_delay_1;
   wire dout0;
   wire rst_dqs_delay;

   parameter TIE_HIGH = 1'b1;

   assign rst_dqs_delay = ~rst_dqs_delay_n;
   assign dout0 = din & rst_dqs_delay_n;
   assign dout = rst_dqs_delay | din_delay_1;

   FDCE delay_ff_1 (.Q(din_delay_1), .C(clk), .CE(TIE_HIGH), .CLR(reset), .D(dout0));



endmodule 

