///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// All Rights Reserved
///////////////////////////////////////////////////////////////////////////////
// ____ ____
// / /\/ /
// /___/ \ / Vendor: Xilinx
// \ \ \/ Version  : 1.5
// \ \ Application : MIG
// / / Filename    : s3_dqs_iob.v
// /___/ /\ 
// \ \ / \
// \___\/\___\
//
//Design Name : s3_dqs_iob
//Description : 
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps
module xst_vlog_bl2cl2_s3_dqs_iob(
	           clk,
	          // clk180,
	           ddr_dqs_reset,
	           ddr_dqs_enable,
	           ddr_dqs,
	           dqs
                   );
               
   input          clk;
 //  input          clk180;   
   input 	  ddr_dqs_reset; 
   input 	  ddr_dqs_enable;   

   inout          ddr_dqs;

   output         dqs; 

   parameter VCC = 1'b1;
   parameter GND = 1'b0; 
   
   wire           dqs_q;
   wire           ddr_dqs_enable1;
   wire           ddr_dqs_enable_b;
   wire           data1;
   

   assign ddr_dqs_enable_b = ~ddr_dqs_enable;
   assign data1 = (ddr_dqs_reset == 1'b1) ? 1'b0 : 1'b1;
 
 
   FD  U1 ( 
         .D(ddr_dqs_enable_b),
         .Q(ddr_dqs_enable1),
         .C(clk)
         );

   FDDRRSE U2 (  
             .Q(dqs_q),
//             .C0(clk180),
             .C0(~clk),
             .C1(clk),
             .CE(VCC),
             .D0(GND),
             .D1(data1),
             .R(GND),
             .S(GND)
             );
             
//***********************************************************************
//    IO buffer for dqs signal. Allows for distribution of dqs
//     to the data (DQ) loads.
//***********************************************************************  

   OBUFT  U3  ( 
            .I(dqs_q), 
            .T(ddr_dqs_enable1),
            .O(ddr_dqs)
            );

   IBUF  U4 ( 
                   .I(ddr_dqs),
                   .O(dqs)
                   );

endmodule 
